diff --git a/external/fmt/test/chrono-test.cc b/external/fmt/test/chrono-test.cc
index b876c151..42360e5f 100644
--- a/external/fmt/test/chrono-test.cc
+++ b/external/fmt/test/chrono-test.cc
@@ -5,77 +5,221 @@
 //
 // For the license information refer to format.h.
 
-#ifdef WIN32
-#  define _CRT_SECURE_NO_WARNINGS
-#endif
-
 #include "fmt/chrono.h"
 
-#include <iomanip>
+#include <ctime>
+#include <vector>
+
+#include "gtest-extra.h"  // EXPECT_THROW_MSG
+#include "util.h"         // get_locale
+
+using fmt::runtime;
 
-#include "gtest-extra.h"
+using testing::Contains;
 
-std::tm make_tm() {
+auto make_tm() -> std::tm {
   auto time = std::tm();
   time.tm_mday = 1;
   return time;
 }
 
-std::tm make_hour(int h) {
+auto make_hour(int h) -> std::tm {
   auto time = make_tm();
   time.tm_hour = h;
   return time;
 }
 
-std::tm make_minute(int m) {
+auto make_minute(int m) -> std::tm {
   auto time = make_tm();
   time.tm_min = m;
   return time;
 }
 
-std::tm make_second(int s) {
+auto make_second(int s) -> std::tm {
   auto time = make_tm();
   time.tm_sec = s;
   return time;
 }
 
-std::string format_tm(const std::tm& time, const char* spec,
-                      const std::locale& loc) {
+std::string system_strftime(const std::string& format, const std::tm* timeptr,
+                            std::locale* locptr = nullptr) {
+  auto loc = locptr ? *locptr : std::locale::classic();
   auto& facet = std::use_facet<std::time_put<char>>(loc);
   std::ostringstream os;
   os.imbue(loc);
-  facet.put(os, os, ' ', &time, spec, spec + std::strlen(spec));
+  facet.put(os, os, ' ', timeptr, format.c_str(),
+            format.c_str() + format.size());
+#ifdef _WIN32
+  // Workaround a bug in older versions of Universal CRT.
+  auto str = os.str();
+  if (str == "-0000") str = "+0000";
+  return str;
+#else
   return os.str();
+#endif
+}
+
+FMT_CONSTEXPR std::tm make_tm(int year, int mon, int mday, int hour, int min,
+                              int sec) {
+  auto tm = std::tm();
+  tm.tm_sec = sec;
+  tm.tm_min = min;
+  tm.tm_hour = hour;
+  tm.tm_mday = mday;
+  tm.tm_mon = mon - 1;
+  tm.tm_year = year - 1900;
+  return tm;
 }
 
-TEST(TimeTest, Format) {
-  std::tm tm = std::tm();
+TEST(chrono_test, format_tm) {
+  auto tm = std::tm();
   tm.tm_year = 116;
   tm.tm_mon = 3;
   tm.tm_mday = 25;
-  EXPECT_EQ("The date is 2016-04-25.",
-            fmt::format("The date is {:%Y-%m-%d}.", tm));
+  tm.tm_hour = 11;
+  tm.tm_min = 22;
+  tm.tm_sec = 33;
+  EXPECT_EQ(fmt::format("The date is {:%Y-%m-%d %H:%M:%S}.", tm),
+            "The date is 2016-04-25 11:22:33.");
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "2016");
+  EXPECT_EQ(fmt::format("{:%C}", tm), "20");
+  EXPECT_EQ(fmt::format("{:%C%y}", tm), fmt::format("{:%Y}", tm));
+  EXPECT_EQ(fmt::format("{:%e}", tm), "25");
+  EXPECT_EQ(fmt::format("{:%D}", tm), "04/25/16");
+  EXPECT_EQ(fmt::format("{:%F}", tm), "2016-04-25");
+  EXPECT_EQ(fmt::format("{:%T}", tm), "11:22:33");
+
+  // Short year
+  tm.tm_year = 999 - 1900;
+  tm.tm_mon = 0;   // for %G
+  tm.tm_mday = 2;  // for %G
+  tm.tm_wday = 3;  // for %G
+  tm.tm_yday = 1;  // for %G
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "0999");
+  EXPECT_EQ(fmt::format("{:%C%y}", tm), "0999");
+  EXPECT_EQ(fmt::format("{:%G}", tm), "0999");
+
+  tm.tm_year = 27 - 1900;
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "0027");
+  EXPECT_EQ(fmt::format("{:%C%y}", tm), "0027");
+
+  // Overflow year
+  tm.tm_year = 2147483647;
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "2147485547");
+
+  tm.tm_year = -2147483648;
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "-2147481748");
+
+  // for week on the year
+  // https://www.cl.cam.ac.uk/~mgk25/iso-time.html
+  std::vector<std::tm> tm_list = {
+      make_tm(1975, 12, 29, 12, 14, 16),  // W01
+      make_tm(1977, 1, 2, 12, 14, 16),    // W53
+      make_tm(1999, 12, 27, 12, 14, 16),  // W52
+      make_tm(1999, 12, 31, 12, 14, 16),  // W52
+      make_tm(2000, 1, 1, 12, 14, 16),    // W52
+      make_tm(2000, 1, 2, 12, 14, 16),    // W52
+      make_tm(2000, 1, 3, 12, 14, 16)     // W1
+  };
+  const std::string iso_week_spec = "%Y-%m-%d: %G %g %V";
+  for (auto ctm : tm_list) {
+    // Calculate tm_yday, tm_wday, etc.
+    std::time_t t = std::mktime(&ctm);
+    tm = *std::localtime(&t);
+
+    auto fmt_spec = fmt::format("{{:{}}}", iso_week_spec);
+    EXPECT_EQ(system_strftime(iso_week_spec, &tm),
+              fmt::format(fmt::runtime(fmt_spec), tm));
+  }
+
+  // Every day from 1970-01-01
+  std::time_t time_now = std::time(nullptr);
+  for (std::time_t t = 6 * 3600; t < time_now; t += 86400) {
+    tm = *std::localtime(&t);
+
+    auto fmt_spec = fmt::format("{{:{}}}", iso_week_spec);
+    EXPECT_EQ(system_strftime(iso_week_spec, &tm),
+              fmt::format(fmt::runtime(fmt_spec), tm));
+  }
+}
+
+// MSVC:
+//  minkernel\crts\ucrt\src\appcrt\time\wcsftime.cpp(971) : Assertion failed:
+//  timeptr->tm_year >= -1900 && timeptr->tm_year <= 8099
+#ifndef _WIN32
+TEST(chrono_test, format_tm_future) {
+  auto tm = std::tm();
+  tm.tm_year = 10445;  // 10000+ years
+  tm.tm_mon = 3;
+  tm.tm_mday = 25;
+  tm.tm_hour = 11;
+  tm.tm_min = 22;
+  tm.tm_sec = 33;
+  EXPECT_EQ(fmt::format("The date is {:%Y-%m-%d %H:%M:%S}.", tm),
+            "The date is 12345-04-25 11:22:33.");
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "12345");
+  EXPECT_EQ(fmt::format("{:%C}", tm), "123");
+  EXPECT_EQ(fmt::format("{:%C%y}", tm), fmt::format("{:%Y}", tm));
+  EXPECT_EQ(fmt::format("{:%D}", tm), "04/25/45");
+  EXPECT_EQ(fmt::format("{:%F}", tm), "12345-04-25");
+  EXPECT_EQ(fmt::format("{:%T}", tm), "11:22:33");
 }
 
-TEST(TimeTest, GrowBuffer) {
-  std::string s = "{:";
+TEST(chrono_test, format_tm_past) {
+  auto tm = std::tm();
+  tm.tm_year = -2001;
+  tm.tm_mon = 3;
+  tm.tm_mday = 25;
+  tm.tm_hour = 11;
+  tm.tm_min = 22;
+  tm.tm_sec = 33;
+  EXPECT_EQ(fmt::format("The date is {:%Y-%m-%d %H:%M:%S}.", tm),
+            "The date is -101-04-25 11:22:33.");
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "-101");
+
+  // macOS  %C - "-1"
+  // Linux  %C - "-2"
+  // fmt    %C - "-1"
+  EXPECT_EQ(fmt::format("{:%C}", tm), "-1");
+  EXPECT_EQ(fmt::format("{:%C%y}", tm), fmt::format("{:%Y}", tm));
+
+  // macOS  %D - "04/25/01" (%y)
+  // Linux  %D - "04/25/99" (%y)
+  // fmt    %D - "04/25/01" (%y)
+  EXPECT_EQ(fmt::format("{:%D}", tm), "04/25/01");
+
+  EXPECT_EQ(fmt::format("{:%F}", tm), "-101-04-25");
+  EXPECT_EQ(fmt::format("{:%T}", tm), "11:22:33");
+
+  tm.tm_year = -1901;  // -1
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "-001");
+  EXPECT_EQ(fmt::format("{:%C%y}", tm), fmt::format("{:%Y}", tm));
+
+  tm.tm_year = -1911;  // -11
+  EXPECT_EQ(fmt::format("{:%Y}", tm), "-011");
+  EXPECT_EQ(fmt::format("{:%C%y}", tm), fmt::format("{:%Y}", tm));
+}
+#endif
+
+TEST(chrono_test, grow_buffer) {
+  auto s = std::string("{:");
   for (int i = 0; i < 30; ++i) s += "%c";
   s += "}\n";
-  std::time_t t = std::time(nullptr);
-  fmt::format(s, *std::localtime(&t));
+  auto t = std::time(nullptr);
+  (void)fmt::format(fmt::runtime(s), *std::localtime(&t));
 }
 
-TEST(TimeTest, FormatToEmptyContainer) {
-  std::string s;
+TEST(chrono_test, format_to_empty_container) {
   auto time = std::tm();
   time.tm_sec = 42;
+  auto s = std::string();
   fmt::format_to(std::back_inserter(s), "{:%S}", time);
   EXPECT_EQ(s, "42");
 }
 
-TEST(TimeTest, EmptyResult) { EXPECT_EQ("", fmt::format("{}", std::tm())); }
+TEST(chrono_test, empty_result) { EXPECT_EQ(fmt::format("{}", std::tm()), ""); }
 
-static bool EqualTime(const std::tm& lhs, const std::tm& rhs) {
+auto equal(const std::tm& lhs, const std::tm& rhs) -> bool {
   return lhs.tm_sec == rhs.tm_sec && lhs.tm_min == rhs.tm_min &&
          lhs.tm_hour == rhs.tm_hour && lhs.tm_mday == rhs.tm_mday &&
          lhs.tm_mon == rhs.tm_mon && lhs.tm_year == rhs.tm_year &&
@@ -83,28 +227,62 @@ static bool EqualTime(const std::tm& lhs, const std::tm& rhs) {
          lhs.tm_isdst == rhs.tm_isdst;
 }
 
-TEST(TimeTest, LocalTime) {
-  std::time_t t = std::time(nullptr);
-  std::tm tm = *std::localtime(&t);
-  EXPECT_TRUE(EqualTime(tm, fmt::localtime(t)));
+TEST(chrono_test, localtime) {
+  auto t = std::time(nullptr);
+  auto tm = *std::localtime(&t);
+  EXPECT_TRUE(equal(tm, fmt::localtime(t)));
+}
+
+TEST(chrono_test, gmtime) {
+  auto t = std::time(nullptr);
+  auto tm = *std::gmtime(&t);
+  EXPECT_TRUE(equal(tm, fmt::gmtime(t)));
 }
 
-TEST(TimeTest, GMTime) {
-  std::time_t t = std::time(nullptr);
-  std::tm tm = *std::gmtime(&t);
-  EXPECT_TRUE(EqualTime(tm, fmt::gmtime(t)));
+template <typename TimePoint> auto strftime_full(TimePoint tp) -> std::string {
+  auto t = std::chrono::system_clock::to_time_t(tp);
+  auto tm = *std::localtime(&t);
+  return system_strftime("%Y-%m-%d %H:%M:%S", &tm);
 }
 
-#define EXPECT_TIME(spec, time, duration)                 \
-  {                                                       \
-    std::locale loc("ja_JP.utf8");                        \
-    EXPECT_EQ(format_tm(time, spec, loc),                 \
-              fmt::format(loc, "{:" spec "}", duration)); \
+TEST(chrono_test, time_point) {
+  auto t1 = std::chrono::system_clock::now();
+  EXPECT_EQ(strftime_full(t1), fmt::format("{:%Y-%m-%d %H:%M:%S}", t1));
+  EXPECT_EQ(strftime_full(t1), fmt::format("{}", t1));
+  using time_point =
+      std::chrono::time_point<std::chrono::system_clock, std::chrono::seconds>;
+  auto t2 = time_point(std::chrono::seconds(42));
+  EXPECT_EQ(strftime_full(t2), fmt::format("{:%Y-%m-%d %H:%M:%S}", t2));
+
+  std::vector<std::string> spec_list = {
+      "%%",  "%n",  "%t",  "%Y",  "%EY", "%y",  "%Oy", "%Ey", "%C",
+      "%EC", "%G",  "%g",  "%b",  "%h",  "%B",  "%m",  "%Om", "%U",
+      "%OU", "%W",  "%OW", "%V",  "%OV", "%j",  "%d",  "%Od", "%e",
+      "%Oe", "%a",  "%A",  "%w",  "%Ow", "%u",  "%Ou", "%H",  "%OH",
+      "%I",  "%OI", "%M",  "%OM", "%S",  "%OS", "%x",  "%Ex", "%X",
+      "%EX", "%D",  "%F",  "%R",  "%T",  "%p",  "%z",  "%Z"};
+  spec_list.push_back("%Y-%m-%d %H:%M:%S");
+#ifndef _WIN32
+  // Disabled on Windows because these formats are not consistent among
+  // platforms.
+  spec_list.insert(spec_list.end(), {"%c", "%Ec", "%r"});
+#endif
+
+  for (const auto& spec : spec_list) {
+    auto t = std::chrono::system_clock::to_time_t(t1);
+    auto tm = *std::localtime(&t);
+
+    auto sys_output = system_strftime(spec, &tm);
+
+    auto fmt_spec = fmt::format("{{:{}}}", spec);
+    EXPECT_EQ(sys_output, fmt::format(fmt::runtime(fmt_spec), t1));
+    EXPECT_EQ(sys_output, fmt::format(fmt::runtime(fmt_spec), tm));
   }
+}
 
 #ifndef FMT_STATIC_THOUSANDS_SEPARATOR
 
-TEST(ChronoTest, FormatDefault) {
+TEST(chrono_test, format_default) {
   EXPECT_EQ("42s", fmt::format("{}", std::chrono::seconds(42)));
   EXPECT_EQ("42as",
             fmt::format("{}", std::chrono::duration<int, std::atto>(42)));
@@ -146,49 +324,7 @@ TEST(ChronoTest, FormatDefault) {
       fmt::format("{}", std::chrono::duration<int, std::ratio<15, 4>>(42)));
 }
 
-TEST(ChronoTest, FormatWide) {
-  EXPECT_EQ(L"42s", fmt::format(L"{}", std::chrono::seconds(42)));
-  EXPECT_EQ(L"42as",
-            fmt::format(L"{}", std::chrono::duration<int, std::atto>(42)));
-  EXPECT_EQ(L"42fs",
-            fmt::format(L"{}", std::chrono::duration<int, std::femto>(42)));
-  EXPECT_EQ(L"42ps",
-            fmt::format(L"{}", std::chrono::duration<int, std::pico>(42)));
-  EXPECT_EQ(L"42ns", fmt::format(L"{}", std::chrono::nanoseconds(42)));
-  EXPECT_EQ(L"42\u00B5s", fmt::format(L"{}", std::chrono::microseconds(42)));
-  EXPECT_EQ(L"42ms", fmt::format(L"{}", std::chrono::milliseconds(42)));
-  EXPECT_EQ(L"42cs",
-            fmt::format(L"{}", std::chrono::duration<int, std::centi>(42)));
-  EXPECT_EQ(L"42ds",
-            fmt::format(L"{}", std::chrono::duration<int, std::deci>(42)));
-  EXPECT_EQ(L"42s", fmt::format(L"{}", std::chrono::seconds(42)));
-  EXPECT_EQ(L"42das",
-            fmt::format(L"{}", std::chrono::duration<int, std::deca>(42)));
-  EXPECT_EQ(L"42hs",
-            fmt::format(L"{}", std::chrono::duration<int, std::hecto>(42)));
-  EXPECT_EQ(L"42ks",
-            fmt::format(L"{}", std::chrono::duration<int, std::kilo>(42)));
-  EXPECT_EQ(L"42Ms",
-            fmt::format(L"{}", std::chrono::duration<int, std::mega>(42)));
-  EXPECT_EQ(L"42Gs",
-            fmt::format(L"{}", std::chrono::duration<int, std::giga>(42)));
-  EXPECT_EQ(L"42Ts",
-            fmt::format(L"{}", std::chrono::duration<int, std::tera>(42)));
-  EXPECT_EQ(L"42Ps",
-            fmt::format(L"{}", std::chrono::duration<int, std::peta>(42)));
-  EXPECT_EQ(L"42Es",
-            fmt::format(L"{}", std::chrono::duration<int, std::exa>(42)));
-  EXPECT_EQ(L"42m", fmt::format(L"{}", std::chrono::minutes(42)));
-  EXPECT_EQ(L"42h", fmt::format(L"{}", std::chrono::hours(42)));
-  EXPECT_EQ(
-      L"42[15]s",
-      fmt::format(L"{}", std::chrono::duration<int, std::ratio<15, 1>>(42)));
-  EXPECT_EQ(
-      L"42[15/4]s",
-      fmt::format(L"{}", std::chrono::duration<int, std::ratio<15, 4>>(42)));
-}
-
-TEST(ChronoTest, Align) {
+TEST(chrono_test, align) {
   auto s = std::chrono::seconds(42);
   EXPECT_EQ("42s  ", fmt::format("{:5}", s));
   EXPECT_EQ("42s  ", fmt::format("{:{}}", s, 5));
@@ -204,7 +340,7 @@ TEST(ChronoTest, Align) {
             fmt::format("{:{}%H:%M:%S}", std::chrono::seconds(12345), 12));
 }
 
-TEST(ChronoTest, FormatSpecs) {
+TEST(chrono_test, format_specs) {
   EXPECT_EQ("%", fmt::format("{:%%}", std::chrono::seconds(0)));
   EXPECT_EQ("\n", fmt::format("{:%n}", std::chrono::seconds(0)));
   EXPECT_EQ("\t", fmt::format("{:%t}", std::chrono::seconds(0)));
@@ -233,43 +369,64 @@ TEST(ChronoTest, FormatSpecs) {
   EXPECT_EQ("s", fmt::format("{:%q}", std::chrono::seconds(12345)));
 }
 
-TEST(ChronoTest, InvalidSpecs) {
+TEST(chrono_test, invalid_specs) {
   auto sec = std::chrono::seconds(0);
-  EXPECT_THROW_MSG(fmt::format("{:%a}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%A}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%c}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%x}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%Ex}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%X}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%EX}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%D}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%F}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%Ec}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%w}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%u}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%b}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%B}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%z}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%Z}", sec), fmt::format_error, "no date");
-  EXPECT_THROW_MSG(fmt::format("{:%Eq}", sec), fmt::format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%a}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%A}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%c}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%x}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%Ex}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%X}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%EX}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%D}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%F}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%Ec}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%w}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%u}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%b}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%B}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%z}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%Z}"), sec), fmt::format_error,
+                   "no date");
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%Eq}"), sec), fmt::format_error,
                    "invalid format");
-  EXPECT_THROW_MSG(fmt::format("{:%Oq}", sec), fmt::format_error,
+  EXPECT_THROW_MSG((void)fmt::format(runtime("{:%Oq}"), sec), fmt::format_error,
                    "invalid format");
 }
 
-TEST(ChronoTest, Locale) {
-  const char* loc_name = "ja_JP.utf8";
-  bool has_locale = false;
-  std::locale loc;
-  try {
-    loc = std::locale(loc_name);
-    has_locale = true;
-  } catch (const std::runtime_error&) {
-  }
-  if (!has_locale) {
-    fmt::print("{} locale is missing.\n", loc_name);
-    return;
-  }
+auto format_tm(const std::tm& time, fmt::string_view spec,
+               const std::locale& loc) -> std::string {
+  auto& facet = std::use_facet<std::time_put<char>>(loc);
+  std::ostringstream os;
+  os.imbue(loc);
+  facet.put(os, os, ' ', &time, spec.begin(), spec.end());
+  return os.str();
+}
+
+TEST(chrono_test, locale) {
+  auto loc = get_locale("ja_JP.utf8");
+  if (loc == std::locale::classic()) return;
+#  define EXPECT_TIME(spec, time, duration)                     \
+    {                                                           \
+      auto jp_loc = std::locale("ja_JP.utf8");                  \
+      EXPECT_EQ(format_tm(time, spec, jp_loc),                  \
+                fmt::format(jp_loc, "{:L" spec "}", duration)); \
+    }
   EXPECT_TIME("%OH", make_hour(14), std::chrono::hours(14));
   EXPECT_TIME("%OI", make_hour(14), std::chrono::hours(14));
   EXPECT_TIME("%OM", make_minute(42), std::chrono::minutes(42));
@@ -283,9 +440,9 @@ TEST(ChronoTest, Locale) {
   EXPECT_TIME("%p", time, sec);
 }
 
-typedef std::chrono::duration<double, std::milli> dms;
+using dms = std::chrono::duration<double, std::milli>;
 
-TEST(ChronoTest, FormatDefaultFP) {
+TEST(chrono_test, format_default_fp) {
   typedef std::chrono::duration<float> fs;
   EXPECT_EQ("1.234s", fmt::format("{}", fs(1.234)));
   typedef std::chrono::duration<float, std::milli> fms;
@@ -295,24 +452,37 @@ TEST(ChronoTest, FormatDefaultFP) {
   EXPECT_EQ("1.234ms", fmt::format("{}", dms(1.234)));
 }
 
-TEST(ChronoTest, FormatPrecision) {
-  EXPECT_THROW_MSG(fmt::format("{:.2}", std::chrono::seconds(42)),
-                   fmt::format_error,
-                   "precision not allowed for this argument type");
+TEST(chrono_test, format_precision) {
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{:.2}"), std::chrono::seconds(42)),
+      fmt::format_error, "precision not allowed for this argument type");
+  EXPECT_EQ("1ms", fmt::format("{:.0}", dms(1.234)));
   EXPECT_EQ("1.2ms", fmt::format("{:.1}", dms(1.234)));
   EXPECT_EQ("1.23ms", fmt::format("{:.{}}", dms(1.234), 2));
+
+  EXPECT_EQ("13ms", fmt::format("{:.0}", dms(12.56)));
+  EXPECT_EQ("12.6ms", fmt::format("{:.1}", dms(12.56)));
+  EXPECT_EQ("12.56ms", fmt::format("{:.2}", dms(12.56)));
 }
 
-TEST(ChronoTest, FormatFullSpecs) {
+TEST(chrono_test, format_full_specs) {
+  EXPECT_EQ("1ms   ", fmt::format("{:6.0}", dms(1.234)));
   EXPECT_EQ("1.2ms ", fmt::format("{:6.1}", dms(1.234)));
   EXPECT_EQ("  1.23ms", fmt::format("{:>8.{}}", dms(1.234), 2));
   EXPECT_EQ(" 1.2ms ", fmt::format("{:^{}.{}}", dms(1.234), 7, 1));
   EXPECT_EQ(" 1.23ms ", fmt::format("{0:^{2}.{1}}", dms(1.234), 2, 8));
   EXPECT_EQ("=1.234ms=", fmt::format("{:=^{}.{}}", dms(1.234), 9, 3));
   EXPECT_EQ("*1.2340ms*", fmt::format("{:*^10.4}", dms(1.234)));
+
+  EXPECT_EQ("13ms  ", fmt::format("{:6.0}", dms(12.56)));
+  EXPECT_EQ("    13ms", fmt::format("{:>8.{}}", dms(12.56), 0));
+  EXPECT_EQ(" 13ms ", fmt::format("{:^{}.{}}", dms(12.56), 6, 0));
+  EXPECT_EQ("  13ms  ", fmt::format("{0:^{2}.{1}}", dms(12.56), 0, 8));
+  EXPECT_EQ("==13ms===", fmt::format("{:=^{}.{}}", dms(12.56), 9, 0));
+  EXPECT_EQ("***13ms***", fmt::format("{:*^10.0}", dms(12.56)));
 }
 
-TEST(ChronoTest, FormatSimpleQq) {
+TEST(chrono_test, format_simple_q) {
   typedef std::chrono::duration<float> fs;
   EXPECT_EQ("1.234 s", fmt::format("{:%Q %q}", fs(1.234)));
   typedef std::chrono::duration<float, std::milli> fms;
@@ -322,34 +492,42 @@ TEST(ChronoTest, FormatSimpleQq) {
   EXPECT_EQ("1.234 ms", fmt::format("{:%Q %q}", dms(1.234)));
 }
 
-TEST(ChronoTest, FormatPrecisionQq) {
-  EXPECT_THROW_MSG(fmt::format("{:.2%Q %q}", std::chrono::seconds(42)),
-                   fmt::format_error,
-                   "precision not allowed for this argument type");
+TEST(chrono_test, format_precision_q) {
+  EXPECT_THROW_MSG(
+      (void)fmt::format(runtime("{:.2%Q %q}"), std::chrono::seconds(42)),
+      fmt::format_error, "precision not allowed for this argument type");
   EXPECT_EQ("1.2 ms", fmt::format("{:.1%Q %q}", dms(1.234)));
   EXPECT_EQ("1.23 ms", fmt::format("{:.{}%Q %q}", dms(1.234), 2));
 }
 
-TEST(ChronoTest, FormatFullSpecsQq) {
+TEST(chrono_test, format_full_specs_q) {
+  EXPECT_EQ("1 ms   ", fmt::format("{:7.0%Q %q}", dms(1.234)));
   EXPECT_EQ("1.2 ms ", fmt::format("{:7.1%Q %q}", dms(1.234)));
   EXPECT_EQ(" 1.23 ms", fmt::format("{:>8.{}%Q %q}", dms(1.234), 2));
   EXPECT_EQ(" 1.2 ms ", fmt::format("{:^{}.{}%Q %q}", dms(1.234), 8, 1));
   EXPECT_EQ(" 1.23 ms ", fmt::format("{0:^{2}.{1}%Q %q}", dms(1.234), 2, 9));
   EXPECT_EQ("=1.234 ms=", fmt::format("{:=^{}.{}%Q %q}", dms(1.234), 10, 3));
   EXPECT_EQ("*1.2340 ms*", fmt::format("{:*^11.4%Q %q}", dms(1.234)));
+
+  EXPECT_EQ("13 ms  ", fmt::format("{:7.0%Q %q}", dms(12.56)));
+  EXPECT_EQ("   13 ms", fmt::format("{:>8.{}%Q %q}", dms(12.56), 0));
+  EXPECT_EQ(" 13 ms  ", fmt::format("{:^{}.{}%Q %q}", dms(12.56), 8, 0));
+  EXPECT_EQ("  13 ms  ", fmt::format("{0:^{2}.{1}%Q %q}", dms(12.56), 0, 9));
+  EXPECT_EQ("==13 ms==", fmt::format("{:=^{}.{}%Q %q}", dms(12.56), 9, 0));
+  EXPECT_EQ("***13 ms***", fmt::format("{:*^11.0%Q %q}", dms(12.56)));
 }
 
-TEST(ChronoTest, InvalidWidthId) {
-  EXPECT_THROW(fmt::format("{:{o}", std::chrono::seconds(0)),
+TEST(chrono_test, invalid_width_id) {
+  EXPECT_THROW((void)fmt::format(runtime("{:{o}"), std::chrono::seconds(0)),
                fmt::format_error);
 }
 
-TEST(ChronoTest, InvalidColons) {
-  EXPECT_THROW(fmt::format("{0}=:{0::", std::chrono::seconds(0)),
+TEST(chrono_test, invalid_colons) {
+  EXPECT_THROW((void)fmt::format(runtime("{0}=:{0::"), std::chrono::seconds(0)),
                fmt::format_error);
 }
 
-TEST(ChronoTest, NegativeDurations) {
+TEST(chrono_test, negative_durations) {
   EXPECT_EQ("-12345", fmt::format("{:%Q}", std::chrono::seconds(-12345)));
   EXPECT_EQ("-03:25:45",
             fmt::format("{:%H:%M:%S}", std::chrono::seconds(-12345)));
@@ -364,16 +542,13 @@ TEST(ChronoTest, NegativeDurations) {
             fmt::format("{:%Q}", std::chrono::duration<int>(min)));
 }
 
-TEST(ChronoTest, SpecialDurations) {
-  EXPECT_EQ(
-      "40.",
-      fmt::format("{:%S}", std::chrono::duration<double>(1e20)).substr(0, 3));
+TEST(chrono_test, special_durations) {
+  auto value = fmt::format("{:%S}", std::chrono::duration<double>(1e20));
+  EXPECT_EQ(value, "40");
   auto nan = std::numeric_limits<double>::quiet_NaN();
   EXPECT_EQ(
       "nan nan nan nan nan:nan nan",
       fmt::format("{:%I %H %M %S %R %r}", std::chrono::duration<double>(nan)));
-  fmt::format("{:%S}",
-              std::chrono::duration<float, std::atto>(1.79400457e+31f));
   EXPECT_EQ(fmt::format("{}", std::chrono::duration<float, std::exa>(1)),
             "1Es");
   EXPECT_EQ(fmt::format("{}", std::chrono::duration<float, std::atto>(1)),
@@ -384,4 +559,67 @@ TEST(ChronoTest, SpecialDurations) {
             "03:33:20");
 }
 
+TEST(chrono_test, unsigned_duration) {
+  EXPECT_EQ("42s", fmt::format("{}", std::chrono::duration<unsigned>(42)));
+}
+
+TEST(chrono_test, weekday) {
+  auto loc = get_locale("ru_RU.UTF-8");
+  std::locale::global(loc);
+  auto mon = fmt::weekday(1);
+
+  auto tm = std::tm();
+  tm.tm_wday = static_cast<int>(mon.c_encoding());
+
+  EXPECT_EQ(fmt::format("{}", mon), "Mon");
+  EXPECT_EQ(fmt::format("{:%a}", tm), "Mon");
+
+  if (loc != std::locale::classic()) {
+    EXPECT_THAT((std::vector<std::string>{"пн", "Пн", "пнд", "Пнд"}),
+                Contains(fmt::format(loc, "{:L}", mon)));
+    EXPECT_THAT((std::vector<std::string>{"пн", "Пн", "пнд", "Пнд"}),
+                Contains(fmt::format(loc, "{:%a}", tm)));
+  }
+}
+
+TEST(chrono_test, cpp20_duration_subsecond_support) {
+  using attoseconds = std::chrono::duration<long long, std::atto>;
+  // Check that 18 digits of subsecond precision are supported.
+  EXPECT_EQ(fmt::format("{:%S}", attoseconds{999999999999999999}),
+            "00.999999999999999999");
+  EXPECT_EQ(fmt::format("{:%S}", attoseconds{673231113420148734}),
+            "00.673231113420148734");
+  EXPECT_EQ(fmt::format("{:%S}", attoseconds{-673231113420148734}),
+            "-00.673231113420148734");
+  EXPECT_EQ(fmt::format("{:%S}", std::chrono::nanoseconds{13420148734}),
+            "13.420148734");
+  EXPECT_EQ(fmt::format("{:%S}", std::chrono::nanoseconds{-13420148734}),
+            "-13.420148734");
+  EXPECT_EQ(fmt::format("{:%S}", std::chrono::milliseconds{1234}), "01.234");
+  {
+    // Check that {:%H:%M:%S} is equivalent to {:%T}.
+    auto dur = std::chrono::milliseconds{3601234};
+    auto formatted_dur = fmt::format("{:%T}", dur);
+    EXPECT_EQ(formatted_dur, "01:00:01.234");
+    EXPECT_EQ(fmt::format("{:%H:%M:%S}", dur), formatted_dur);
+  }
+  using nanoseconds_dbl = std::chrono::duration<double, std::nano>;
+  EXPECT_EQ(fmt::format("{:%S}", nanoseconds_dbl{-123456789}), "-00.123456789");
+  EXPECT_EQ(fmt::format("{:%S}", nanoseconds_dbl{9123456789}), "09.123456789");
+  // Verify that only the seconds part is extracted and printed.
+  EXPECT_EQ(fmt::format("{:%S}", nanoseconds_dbl{99123456789}), "39.123456789");
+  EXPECT_EQ(fmt::format("{:%S}", nanoseconds_dbl{99123000000}), "39.123000000");
+  {
+    // Now the hour is printed, and we also test if negative doubles work.
+    auto dur = nanoseconds_dbl{-99123456789};
+    auto formatted_dur = fmt::format("{:%T}", dur);
+    EXPECT_EQ(formatted_dur, "-00:01:39.123456789");
+    EXPECT_EQ(fmt::format("{:%H:%M:%S}", dur), formatted_dur);
+  }
+  // Check that durations with precision greater than std::chrono::seconds have
+  // fixed precision, and print zeros even if there is no fractional part.
+  EXPECT_EQ(fmt::format("{:%S}", std::chrono::microseconds{7000000}),
+            "07.000000");
+}
+
 #endif  // FMT_STATIC_THOUSANDS_SEPARATOR
diff --git a/external/fmt/test/color-test.cc b/external/fmt/test/color-test.cc
index 454a0660..af8f1494 100644
--- a/external/fmt/test/color-test.cc
+++ b/external/fmt/test/color-test.cc
@@ -7,62 +7,29 @@
 
 #include "fmt/color.h"
 
-#include "gtest-extra.h"
+#include <iterator>  // std::back_inserter
 
-TEST(ColorsTest, ColorsPrint) {
-  EXPECT_WRITE(stdout, fmt::print(fg(fmt::rgb(255, 20, 30)), "rgb(255,20,30)"),
-               "\x1b[38;2;255;020;030mrgb(255,20,30)\x1b[0m");
-  EXPECT_WRITE(stdout, fmt::print(fg(fmt::color::blue), "blue"),
-               "\x1b[38;2;000;000;255mblue\x1b[0m");
-  EXPECT_WRITE(
-      stdout,
-      fmt::print(fg(fmt::color::blue) | bg(fmt::color::red), "two color"),
-      "\x1b[38;2;000;000;255m\x1b[48;2;255;000;000mtwo color\x1b[0m");
-  EXPECT_WRITE(stdout, fmt::print(fmt::emphasis::bold, "bold"),
-               "\x1b[1mbold\x1b[0m");
-  EXPECT_WRITE(stdout, fmt::print(fmt::emphasis::italic, "italic"),
-               "\x1b[3mitalic\x1b[0m");
-  EXPECT_WRITE(stdout, fmt::print(fmt::emphasis::underline, "underline"),
-               "\x1b[4munderline\x1b[0m");
-  EXPECT_WRITE(stdout,
-               fmt::print(fmt::emphasis::strikethrough, "strikethrough"),
-               "\x1b[9mstrikethrough\x1b[0m");
-  EXPECT_WRITE(
-      stdout,
-      fmt::print(fg(fmt::color::blue) | fmt::emphasis::bold, "blue/bold"),
-      "\x1b[1m\x1b[38;2;000;000;255mblue/bold\x1b[0m");
-  EXPECT_WRITE(stderr, fmt::print(stderr, fmt::emphasis::bold, "bold error"),
-               "\x1b[1mbold error\x1b[0m");
-  EXPECT_WRITE(stderr, fmt::print(stderr, fg(fmt::color::blue), "blue log"),
-               "\x1b[38;2;000;000;255mblue log\x1b[0m");
-  EXPECT_WRITE(stdout, fmt::print(fmt::text_style(), "hi"), "hi");
-  EXPECT_WRITE(stdout, fmt::print(fg(fmt::terminal_color::red), "tred"),
-               "\x1b[31mtred\x1b[0m");
-  EXPECT_WRITE(stdout, fmt::print(bg(fmt::terminal_color::cyan), "tcyan"),
-               "\x1b[46mtcyan\x1b[0m");
-  EXPECT_WRITE(stdout,
-               fmt::print(fg(fmt::terminal_color::bright_green), "tbgreen"),
-               "\x1b[92mtbgreen\x1b[0m");
-  EXPECT_WRITE(stdout,
-               fmt::print(bg(fmt::terminal_color::bright_magenta), "tbmagenta"),
-               "\x1b[105mtbmagenta\x1b[0m");
-}
+#include "gtest-extra.h"  // EXPECT_WRITE
 
-TEST(ColorsTest, Format) {
+TEST(color_test, format) {
   EXPECT_EQ(fmt::format(fg(fmt::rgb(255, 20, 30)), "rgb(255,20,30)"),
             "\x1b[38;2;255;020;030mrgb(255,20,30)\x1b[0m");
-  EXPECT_EQ(fmt::format(fg(fmt::rgb(255, 20, 30)), L"rgb(255,20,30) wide"),
-            L"\x1b[38;2;255;020;030mrgb(255,20,30) wide\x1b[0m");
   EXPECT_EQ(fmt::format(fg(fmt::color::blue), "blue"),
             "\x1b[38;2;000;000;255mblue\x1b[0m");
   EXPECT_EQ(
       fmt::format(fg(fmt::color::blue) | bg(fmt::color::red), "two color"),
       "\x1b[38;2;000;000;255m\x1b[48;2;255;000;000mtwo color\x1b[0m");
   EXPECT_EQ(fmt::format(fmt::emphasis::bold, "bold"), "\x1b[1mbold\x1b[0m");
+  EXPECT_EQ(fmt::format(fmt::emphasis::faint, "faint"), "\x1b[2mfaint\x1b[0m");
   EXPECT_EQ(fmt::format(fmt::emphasis::italic, "italic"),
             "\x1b[3mitalic\x1b[0m");
   EXPECT_EQ(fmt::format(fmt::emphasis::underline, "underline"),
             "\x1b[4munderline\x1b[0m");
+  EXPECT_EQ(fmt::format(fmt::emphasis::blink, "blink"), "\x1b[5mblink\x1b[0m");
+  EXPECT_EQ(fmt::format(fmt::emphasis::reverse, "reverse"),
+            "\x1b[7mreverse\x1b[0m");
+  EXPECT_EQ(fmt::format(fmt::emphasis::conceal, "conceal"),
+            "\x1b[8mconceal\x1b[0m");
   EXPECT_EQ(fmt::format(fmt::emphasis::strikethrough, "strikethrough"),
             "\x1b[9mstrikethrough\x1b[0m");
   EXPECT_EQ(
@@ -84,3 +51,16 @@ TEST(ColorsTest, Format) {
   EXPECT_EQ(fmt::format(fg(fmt::terminal_color::red), "{}", "foo"),
             "\x1b[31mfoo\x1b[0m");
 }
+
+TEST(color_test, format_to) {
+  auto out = std::string();
+  fmt::format_to(std::back_inserter(out), fg(fmt::rgb(255, 20, 30)),
+                 "rgb(255,20,30){}{}{}", 1, 2, 3);
+  EXPECT_EQ(fmt::to_string(out),
+            "\x1b[38;2;255;020;030mrgb(255,20,30)123\x1b[0m");
+}
+
+TEST(color_test, print) {
+  EXPECT_WRITE(stdout, fmt::print(fg(fmt::rgb(255, 20, 30)), "rgb(255,20,30)"),
+               "\x1b[38;2;255;020;030mrgb(255,20,30)\x1b[0m");
+}
